******
**** CREATION OF MAIN DATABASE
****
**** STEP 2: Merge store-level data (not really used for this project)
******



** <<IMPORTANT>> Note: Use directory of this code as working directory


******** PREPARE STORE INFO DATASET (from IRI)

clear
clear matrix
clear mata
set memory 3000m
set more off
set matsize 600*log using d:\stata\programs\capstruct\mylog, replace 
display "Start loop"

foreach YEAR in Year1 Year2 Year3 Year4 Year5 Year6 Year7 Year8 Year9 Year10 Year11{

		clear
		clear matrix
		clear mata
		display "`YEAR'"
		

		** Create file names
		local infilename = "../IRI_dbases_input/"+"`YEAR'"+"/External/beer/Delivery_Stores.txt"
		local outfilename = "../IRI_dbases_output/"+"`YEAR'"+"/Delivery_Stores_"+"`YEAR'"
		
		** Load original database
		insheet using "`infilename'", tab case

		gen YEAR = "`YEAR'"
		
		** Save database in Stata format
		save "`outfilename'", replace
}



******** MERGE STORE INFO WITH MAIN DATABASES

clear all

foreach CAT in beer coldcer fzdinent fzpizza saltsnck yogurt{
	foreach YEAR in Year1 Year2 Year3 Year4 Year5 Year6 Year7 Year8 Year9 Year10 Year11{

		clear
		clear matrix
		clear mata
		display "`CAT'"
		display "`YEAR'"
		
		** Remove IRI_KEY (store identifiers) that are assigned to two different chains
		local storefilename = "../IRI_dbases_output/"+"`YEAR'"+"/Delivery_Stores_"+"`YEAR'"
		local storefilenametemp = "../IRI_dbases_output/"+"`YEAR'"+"/Delivery_Stores_"+"`YEAR'"+"_temp"
		use "`storefilename'"
		sort IRI_KEY
		gen dup1=IRI_KEY[_n]-IRI_KEY[_n-1]
		gen dup2=IRI_KEY[_n+1]-IRI_KEY[_n]
		replace MskdName="NA" if dup1==1|dup2==1
		
		replace EST_ACV=. if dup1==1|dup2==1
		replace Open=. if dup1==1|dup2==1
		replace Clsd=. if dup1==1|dup2==1
		drop if dup1==0
		drop dup1
		drop dup2
		
		save "`storefilenametemp'", replace
		
		clear
		clear matrix
		clear mata

		
		** Load original data in Stata format
		local infilename = "../IRI_dbases_output/"+"`YEAR'"+"/"+"`CAT'"+"_groc_"+"`YEAR'"		
		use "`infilename'"
		
		
		** Merge with store data
		local storefilename = "../IRI_dbases_output/"+"`YEAR'"+"/Delivery_Stores_"+"`YEAR'"
		merge m:1 IRI_KEY using "`storefilenametemp'"
		drop _merge
		
		** Save data
		local outfilename = "../IRI_dbases_output/"+"`YEAR'"+"/"+"`CAT'"+"_groc_"+"`YEAR'"+"_IRIinfo"
		save "`outfilename'", replace
		
	}
}
