********************************************************************************************************************************************
** Creates and saves weights for the aggregate moments
** 
********************************************************************************************************************************************

clear
clear matrix
clear mata
set more off
set matsize 600

** <<IMPORTANT>> Note: Use directory of this code as working directory

save "../data/weights_for_moments_MKT_CAT_april2020", emptyok replace



foreach MKT in ATL BOS CHI DAL HOU LA NYC PHI SF {
	foreach CAT in beer coldcer fzdinent fzpizza saltsnck yogurt{

		***
		*** Load data
		***

		local infilename ="../data/allprices_allyears_wsales_"+"`CAT'"+"_"+"`MKT'"
		use "`infilename'"
		
		gen CAT = "`CAT'"
		gen MKT = "`MKT'"
		display "`MKT'"
		display "`CAT'"

		****
		**** New variables
		****
		
		gen DOLLARS_REG = DOLLARS if REGPRICE==PRICE_ORIG
		gen REGPRICE_posted = REGPRICE if REGPRICE==PRICE_ORIG

		***********
		* Collapse
		***********
		collapse (count) REGPRICE_posted PRICE_ORIG REGPRICE (sum) DOLLARS DOLLARS_REG , by(CAT MKT)
		
		append using "../data/weights_for_moments_MKT_CAT_april2020"
		save "../data/weights_for_moments_MKT_CAT_april2020", replace

	}		

}

