
%%%% Faster, but less flexible version of GPupdate_slr.m

function [GPupdate, PostVar, alpha] = GPupdate_slr_v3(data,p,gamma_h,b_h,gamma_l,b_l,sigma_z,psi, sigma_x,pGrid, b_max)%ldmm0(x,P,Q,q_h,s_h,q_l,s_l,alpha,sigma,pGrid)
%%


pU    = data(:,1); %sorted and unique prices
yM    = data(:,2); %sorted mean for quantities
ySE    = sigma_z./sqrt(data(:,3)); %sorted standard-deviation for quantities

n = length(pU);


%%% Compute alpha -- the vector of weights for the signals where
%%%  E(x(p) | y ) = m(p) + alpha'(y - m)
%%% Start with expressing everything as multivariate normal

Sigma12 = NaN(length(p),n);
Kp0p1 = NaN(n,n);

%alpha = NaN(length(p), length(pU));


for i = 1:n
    
    %%% Squared exponential variance function -- alpha's might be negative!
    Kp0p1(:,i) = sigma_x^2*exp(-psi^2*(pU - pU(i)).^2);
    
end
%}
temp = bsxfun(@minus, p', pU');
Sigma12  = sigma_x^2*exp(-psi^2*temp.^2);



Sigma22 = Kp0p1 + diag(ones(n,1).*(ySE.^2));

alpha = Sigma12/Sigma22;
PostVar = (sigma_x^2 - sum(alpha.*Sigma12,2))';

%%% Compute worst-case demand

GPupdate = NaN(1,length(p));

slr_max = bsxfun(@minus,gamma_l + (b_h+abs(b_max))*p(p> pU(end)), abs(b_max)*pU);  %%% max worst-case prior m*(p), given slope restrictions
GPupdate(p>pU(end)) = gamma_l + b_h*p(p>pU(end))' + sum(alpha(p> pU(end),:).*(bsxfun(@minus,yM, bsxfun(@min,slr_max,gamma_h + b_h*pU)))',2);

for i=1:n-1
    ind_below = 1:n-i;
    ind_above = n-i+1:n;
    slr_max = bsxfun(@minus,gamma_l + (b_h+abs(b_max))*p(p> pU(end-i) & p<= pU(end-i+1)), abs(b_max)*pU(ind_below));  %%% max worst-case prior m*(p), given slope restrictions
    yhat_low = sum(alpha(p> pU(end-i) & p<= pU(end-i+1),ind_below).*(bsxfun(@minus,yM(ind_below), bsxfun(@min,slr_max,gamma_h + b_h*pU(ind_below))))',2);
    
    yhat_high = sum(alpha(p> pU(end-i) & p<= pU(end-i+1),ind_above).*(bsxfun(@minus,yM(ind_above), bsxfun(@min,gamma_l +  b_h*p(p> pU(end-i) & p<= pU(end-i+1)),gamma_h + b_h*pU(ind_above))))',2);
    GPupdate(p> pU(end-i) & p<= pU(end-i+1)) = (gamma_l + b_h*p(p> pU(end-i) & p<= pU(end-i+1)))' + yhat_low + yhat_high;
end

GPupdate(p<= pU(1)) = (gamma_l + b_h*p(p<=pU(1)))' + sum(alpha(p<=pU(1),:).*(bsxfun(@minus,yM, bsxfun(@min,gamma_l +  b_h*p(p<=pU(1)),gamma_h + b_h*pU)))',2);

end
