
%%
%%%


pmax_sims_orig = pmax_sims;
pmax_menuc_sims_orig = pmax_menuc_sims;
rmax_sims_orig = rmax_sims;
y_hist_sims_orig = y_hist_sims;
pjs_sims_orig    = pjs_sims;

pmax_sims = pmax_sims( 1 + burn_in:end,:);
rmax_sims = rmax_sims(1 +burn_in:end,:);
y_hist_sims = y_hist_sims(1 +burn_in:end,:);
pjs_sims = pjs_sims(1 +burn_in:end,:);
n_hist_sims = n_hist_sims(1 +burn_in:end,:);
pmax_menuc_sims = pmax_menuc_sims(1 +burn_in:end,:);
lambdaPhi_rand_mat = lambdaPhi_rand_mat( 1 + burn_in:end,:);
z_sims             = z_sims( 1 + burn_in:end,:);
%w_sims             = w_sims( 1 + burn_in:end,:);
%eps_w_mat          = eps_w_mat_temp( 1 + burn_in:end,:);

T_sims = size(pmax_sims,1);

firm_birth_index = lambdaPhi_rand_mat <= lam_phi;

new_firms = sum(firm_birth_index(:));
num_firms_augm = num_firms + new_firms;

[row_idx, col_idx ] = find(lambdaPhi_rand_mat <= lam_phi);

%%%
start_index = NaN(1,num_firms_augm);
end_index   = NaN(1,num_firms_augm);
firm_col_idx = NaN(1,num_firms_augm);

counter = 1;

for ii = 1:num_firms
    
    idx_temp = find(col_idx == ii);
    
    if isempty(idx_temp)
        
        start_index(ii) = 1;
        end_index(ii)   = T_sims;
        firm_col_idx(ii)   = ii;
        continue
    end
    
    row_temp =  row_idx(idx_temp);
    
    for jj = 1:length(idx_temp)-1
        
        if row_temp(jj) == 1
            continue
        end
        idx_start = row_temp(jj);
        idx_end   = row_temp(jj+1)-1;
        
        
        start_index(num_firms+counter) = idx_start;
        end_index(num_firms+counter)   = idx_end;
        firm_col_idx(num_firms + counter) = ii;
        
        
        counter = counter + 1;
    end
    
    start_index(num_firms + counter) = row_temp(end);
    end_index(num_firms + counter)   = T_sims;
    firm_col_idx(num_firms + counter) = ii;
    
    counter = counter + 1;
    
    start_index(ii)     = 1;
    if row_temp(1) == 1
        end_index(ii)       = row_temp(2) - 1;
    else
        end_index(ii)       = row_temp(1) - 1;
        
    end
    firm_col_idx(ii)    = ii;
    
end

start_index = start_index(isfinite(start_index));
end_index = end_index(isfinite(end_index));
firm_col_idx = firm_col_idx(isfinite(firm_col_idx));

num_firms_augm = size(start_index,2);

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Computing moments out of the simulation results
%%%% Set window sizes
window_length = 13;         %%% size of window that defines a "regime"
window_revisit = 26;        %%% window for computing probability of revisiting prices
window_revisit_modalp = 52; %%% window for computing probability of revisiting modal price


dp = pmax_sims(2:end,:) - pmax_sims(1:end-1,:);
dp( lambdaPhi_rand_mat(2:size(lambdaPhi_rand_mat,1),:) <= lam_phi ) = NaN;

num_dp =  sum( abs(dp) > 0 );

freq_dp = mean(abs(dp(isfinite(dp))) > 0);

abs_dp = abs(dp);

dp_size =  median( abs_dp(abs_dp>0));

dp_incr_frac = sum(dp(abs_dp>0)>0)/sum(abs_dp(:)>0);

%%% Modal price
frac_at_modalp = NaN(T_sims ,num_firms);
maxp_modal_ind = NaN(T_sims ,num_firms);
num_unique = NaN(T_sims ,num_firms);
mod_price  = NaN(T_sims ,num_firms);
pdp_ratio26  = NaN(T_sims , num_firms);
num_unique26 = NaN(T_sims , num_firms);

frac_at_modalp_menuc = NaN(T_sims ,num_firms);
maxp_modal_ind_menuc = NaN(T_sims ,num_firms);
reuse_modprice6   = NaN(T_sims, num_firms);
reuse_modprice13   = NaN(T_sims, num_firms);
reuse_modprice26   = NaN(T_sims, num_firms);
reuse_modprice6_unc   = NaN(T_sims, num_firms);
reuse_modprice13_unc   = NaN(T_sims, num_firms);
reuse_modprice26_unc   = NaN(T_sims, num_firms);

for ii = 1:num_firms_augm
    pmax_firm_ii     = pmax_sims(:,firm_col_idx(ii));
    start_index_temp = start_index(ii);
    end_index_temp   = end_index(ii);
    
    mod_price_temp       = NaN(T_sims,1);
    frac_at_modalp_temp  = NaN(T_sims ,1);
    num_unique_temp      = NaN(T_sims ,1);
    maxp_modal_ind_temp  = NaN(T_sims ,1);
    reuse_modprice6_temp = NaN(T_sims,1);
    reuse_modprice13_temp = NaN(T_sims,1);
    reuse_modprice26_temp = NaN(T_sims,1);
    reuse_modprice6_unc_temp = NaN(T_sims,1);
    reuse_modprice13_unc_temp = NaN(T_sims,1);
    reuse_modprice26_unc_temp = NaN(T_sims,1); 
    
    for t = start_index_temp+(window_length-1)/2:end_index_temp - (window_length-1)/2
        
        %pmax_temp = pmax_firm_ii(t:t + window_length-1);
        pmax_temp = pmax_firm_ii(max(t-(window_length-1)/2,1):min(t+(window_length-1)/2,T_sims));
        
        modal_price = mode(pmax_temp);
        
        mod_price_temp(t) = modal_price;
        
        ind_at_modalp = (pmax_temp == modal_price);
        frac_at_modalp_temp(t) = sum(ind_at_modalp)/window_length;
        
        num_unique_temp(t) = length(unique(pmax_temp));
        
        maxp_modal_ind_temp(t) = (max(pmax_temp) == modal_price);
                
        if t > start_index_temp+(window_length-1)/2
            if mod_price_temp(t) ~= mod_price_temp(t-1)
                
       
                t_start = find( pmax_firm_ii(t:t+6) == mod_price_temp(t), 1);
                if sum(abs(diff(pmax_firm_ii(t  + t_start - 1: min( t + 6, end_index_temp)))) > 0)>0
                    reuse_modprice6_temp(t) = sum(pmax_firm_ii(t  + t_start - 1: min( t + 6, end_index_temp)) == mod_price_temp(t-1)) > 0;
                end
                
                if sum(abs(diff(pmax_firm_ii(t  + t_start - 1: min( t + 13, end_index_temp)))) > 0)>0
                    
                    reuse_modprice13_temp(t) = sum(pmax_firm_ii(t + t_start - 1: min( t + 13, end_index_temp)) == mod_price_temp(t-1)) > 0;
                
                end
                
                if sum(abs(diff(pmax_firm_ii(t  + t_start - 1: min( t + 26, end_index_temp)))) > 0)>0
                
                    reuse_modprice26_temp(t) = sum(pmax_firm_ii(t + t_start - 1: min( t + 26, end_index_temp)) == mod_price_temp(t-1)) > 0;
                
                end
                    reuse_modprice6_unc_temp(t)  = sum(pmax_firm_ii(t  + t_start - 1: min( t + 6, end_index_temp)) == mod_price_temp(t-1)) > 0;
                    reuse_modprice13_unc_temp(t) = sum(pmax_firm_ii(t  + t_start - 1: min( t + 13, end_index_temp)) == mod_price_temp(t-1)) > 0;
                    reuse_modprice26_unc_temp(t) = sum(pmax_firm_ii(t  + t_start - 1: min( t + 26, end_index_temp)) == mod_price_temp(t-1)) > 0;

                
                
            end
        end
        
    end
    
    
    
    mod_price(isfinite(mod_price_temp),firm_col_idx(ii))      = mod_price_temp(isfinite(mod_price_temp));
    frac_at_modalp(isfinite(frac_at_modalp_temp),firm_col_idx(ii)) = frac_at_modalp_temp(isfinite(frac_at_modalp_temp));
    num_unique(isfinite(num_unique_temp),firm_col_idx(ii))     = num_unique_temp(isfinite(num_unique_temp));
    maxp_modal_ind(isfinite(maxp_modal_ind_temp),firm_col_idx(ii)) = maxp_modal_ind_temp(isfinite(maxp_modal_ind_temp));
    
    reuse_modprice6(isfinite(mod_price_temp),firm_col_idx(ii))      = reuse_modprice6_temp(isfinite(mod_price_temp));
    reuse_modprice13(isfinite(mod_price_temp),firm_col_idx(ii))      = reuse_modprice13_temp(isfinite(mod_price_temp));
    reuse_modprice26(isfinite(mod_price_temp),firm_col_idx(ii))      = reuse_modprice26_temp(isfinite(mod_price_temp));
    
    reuse_modprice6_unc(isfinite(mod_price_temp),firm_col_idx(ii))      = reuse_modprice6_unc_temp(isfinite(mod_price_temp));
    reuse_modprice13_unc(isfinite(mod_price_temp),firm_col_idx(ii))      = reuse_modprice13_unc_temp(isfinite(mod_price_temp));
    reuse_modprice26_unc(isfinite(mod_price_temp),firm_col_idx(ii))      = reuse_modprice26_unc_temp(isfinite(mod_price_temp));
    
    
end

for ii = 1:num_firms_augm
    pmax_sims_ii = pmax_sims(:,firm_col_idx(ii));
    start_index_temp = start_index(ii);
    end_index_temp   = end_index(ii);
    
    num_unique26_temp = NaN(T_sims, 1);
    pdp_ratio26_temp  = NaN(T_sims, 1);
    
    for t = start_index_temp:end_index_temp - window_revisit + 1
        pmax_temp = pmax_sims_ii(t:t + window_revisit - 1);
        
        num_unique26_temp(t) = length(unique(pmax_temp));
        pdp_ratio26_temp(t) = length(unique(pmax_temp))/( sum( abs(diff(pmax_temp)) > 0) + 1);
    end
    
    num_unique26(isfinite(num_unique26_temp),firm_col_idx(ii)) = num_unique26_temp(isfinite(num_unique26_temp));
    pdp_ratio26(isfinite(pdp_ratio26_temp),firm_col_idx(ii))  = pdp_ratio26_temp(isfinite(pdp_ratio26_temp));
end


non_mod_price = real(pmax_sims ~= mod_price);
non_mod_price(isnan(mod_price)) = NaN;

%%%%% Duration
med_duration_firm = NaN( num_firms_augm,1);
duration_vec = [];

regime_shifts = NaN(T_sims, num_firms); 


for ii = 1:num_firms_augm
    pmax_temp = pmax_sims(:,firm_col_idx(ii));
    pmax_temp = pmax_temp(start_index(ii):end_index(ii));
    
    [temp,~] = break_test_basic(pmax_temp,5,.61);
    
    temp2=find(temp);
    
    %Duration of each regime (we drop first and last spells)
    duration = temp2(2:end)-temp2(1:end-1);
    med_duration_firm(ii)=median(duration);
    if isempty(duration)
        continue
    end
    %duration_vec = [duration_vec;duration];
    duration_vec = [duration_vec; duration];
    
    regime_shifts(start_index(ii):end_index(ii), firm_col_idx(ii)) = temp; 
    
end



duration_vec = duration_vec( isfinite(duration_vec));
median_duration=median(duration_vec);
quartiles=quantile(duration_vec,[0.01, 0.05, .1, 0.25, .50, 0.75, .9, 0.95, 0.99]);
mean_duration=mean(duration_vec);


dp_mod  = mod_price(2:end,:) - mod_price(1:end-1,:);
dp_mod( lambdaPhi_rand_mat(2:end,:) <= lam_phi ) = NaN;

num_dp_mod =  sum( abs(dp_mod)>0 );
freq_dp_mod = mean( abs(dp_mod( isfinite(dp_mod))) > 0 );


%dp = dp(abs_dp>0);

%%
revisit_ind_mat = NaN(size(pmax_sims,1),num_firms);

revisit_ind_moddp_mat = NaN(size(pmax_sims,1), num_firms); 
revisit_ind_moddp_matb = NaN(size(pmax_sims,1), num_firms); 

revisit_ind_regshift_mat = NaN(size(pmax_sims,1), num_firms); 
revisit_ind_regshift_mat2 = NaN(size(pmax_sims,1), num_firms); 

revisit_ind_modprice_mat = NaN(size(pmax_sims,1), num_firms); 
revisit_ind_modprice_mat2 = NaN(size(pmax_sims,1), num_firms); 

revisit_ind_newprice_mat = NaN(size(pmax_sims,1), num_firms); 
revisit_ind_newprice_unc_mat = NaN(size(pmax_sims,1), num_firms); 

revisit_ind_newprice_mat2 = NaN(size(pmax_sims,1), num_firms); 
revisit_ind_newprice_unc_mat2 = NaN(size(pmax_sims,1), num_firms); 
reset_ind_newprice_mat   = NaN(size(pmax_sims,1), num_firms); 
reset_ind_newprice_mat2   = NaN(size(pmax_sims,1), num_firms); 
reset_ind_mat             = NaN(size(pmax_sims,1), num_firms); 

return_mod_ind_mat = NaN(size(pmax_sims,1),num_firms);
return_mod_ind_mat2 = return_mod_ind_mat;

revisit_N_mat = NaN( T_sims, num_firms);
revisit_relN_mat = NaN(T_sims, num_firms);

%%%
for ii = 1:num_firms_augm
    pmax_temp = pmax_sims(:,firm_col_idx(ii));
    pjs_temp  = pjs_sims(:,firm_col_idx(ii)); 
    pagg_temp = p_agg_sims(burn_in+1:end, 1); 
    
    pmax      = NaN(size(pmax_temp));
    pjs       = pmax; 
    mod_price_temp = NaN(size(pmax_temp));
    regime_shifts_temp = pmax;
    
    pmax(start_index(ii):end_index(ii)) = pmax_temp(start_index(ii):end_index(ii));
    pjs(start_index(ii):end_index(ii)) = pjs_temp(start_index(ii):end_index(ii));
    
    mod_price_temp(start_index(ii):end_index(ii)) = mod_price(start_index(ii):end_index(ii),firm_col_idx(ii));
    regime_shifts_temp(start_index(ii):end_index(ii)) = regime_shifts(start_index(ii):end_index(ii),firm_col_idx(ii));
    
    abs_dp_temp = abs(diff(pmax));
    moves_ind = find(abs_dp_temp>0) + 1;
    num_moves = length(moves_ind);
    
    abs_moddp_temp = abs(diff(mod_price_temp));
    movesmod_ind = find(abs_moddp_temp>0) + 1;
    num_moves_mod = length(movesmod_ind);
    
    revisit_ind      = NaN(T_sims,1);
    revisit_ind_up   = NaN(T_sims,1);
    revisit_ind_down = NaN(T_sims,1);
    
    revisit_ind_moddp = revisit_ind; 
    revisit_ind_moddpb = revisit_ind; 
    
    revisit_ind_regshift = revisit_ind; 
    revisit_ind_regshift2 = revisit_ind; 
    
    revisit_ind_modprice = revisit_ind; 
    revisit_ind_modprice2 = revisit_ind; 
    %revisit_ind_modprice_unc = revisit_ind; 
    %revisit_ind_modprice2_unc = revisit_ind; 
    
    revisit_ind_newprice     = revisit_ind; 
    revisit_ind_newprice_unc     = revisit_ind; 
    revisit_ind_newprice2     = revisit_ind; 
    revisit_ind_newprice_unc2     = revisit_ind; 
    reset_ind_newprice       = revisit_ind; 
    reset_ind_newprice2       = revisit_ind; 
    
    reset_ind = revisit_ind; 

    bounce_ind      = NaN(T_sims,1);
    return_mod_ind  = NaN(T_sims,1);
    return_mod_ind2 = NaN(T_sims,1);

    
    revisit_N    = NaN(T_sims,1);
    revisit_relN = NaN(T_sims,1);
    
    j_up = 1;
    j_down = 1;
    
    for j = 2:length(moves_ind)
        
        if moves_ind(j) - moves_ind(j-1) <= window_revisit
            revisit_ind(moves_ind(j)) = ( sum( pmax(moves_ind(j)) == pmax(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1)) >0 );
        end
        
        mod_price_lag_finite = mod_price_temp(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1);
        mod_price_lag_finite = mod_price_lag_finite( isfinite(mod_price_lag_finite)); 
        
        if sum(mod_price_temp(moves_ind(j)) ~= mod_price_lag_finite)>0  
            
            %revisit_ind_moddp(moves_ind(j)) = ( sum( pmax(moves_ind(j)) == pmax(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1)) >0 );
            
            
            moddp_ind = length(mod_price_temp(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1)) + 1 - find( mod_price_temp(moves_ind(j)) ~= mod_price_temp(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1), 1, 'last');
            revisit_ind_moddp(moves_ind(j)) = ( sum( pmax(moves_ind(j)) == pmax(max(moves_ind(j) - window_revisit,1):max([moves_ind(j)-moddp_ind - 1,1]))) >0 );
            
            if sum( moves_ind(j-1) == [moves_ind(j) - moddp_ind + 1 : moves_ind(j)]) == 0
                
               revisit_ind_moddpb(moves_ind(j)) = ( sum( pmax(moves_ind(j)) == pmax(max(moves_ind(j) - window_revisit,1):max([moves_ind(j)-moddp_ind - 1,1]))) >0 );

            end
            
            
        end
        
           
        if sum(regime_shifts_temp( max([moves_ind(j) - window_revisit,1]) : moves_ind(j) - 1))>0  
            
            revisit_ind_regshift(moves_ind(j)) = ( sum( pmax(moves_ind(j)) == pmax(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1)) >0 );
            
            
            regshift_ind = length(regime_shifts_temp(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1)) - find( regime_shifts_temp(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1)  == 1, 1, 'last');
            revisit_ind_regshift2(moves_ind(j)) = ( sum( pmax(moves_ind(j)) == pmax(max(moves_ind(j) - window_revisit,1):max([moves_ind(j)-regshift_ind - 1,1]))) >0 );
        end
        
        reset_ind(moves_ind(j)) = pjs(moves_ind(j)) == pagg_temp(moves_ind(j));

                              
        if j < length(moves_ind)
            if sum( pmax(moves_ind(j)) == pmax(max(moves_ind(j) - window_revisit_modalp,1):moves_ind(j)-1)) == 0
                
                
                temp_moves_bck = find( moves_ind(1:j-1)  >= moves_ind(j)  - window_revisit);
                new_price_bck  = 0; 
                
                for i_move_back = temp_moves_bck'
                   
                    if  sum( pmax(moves_ind(i_move_back)) == pmax(max([moves_ind(i_move_back) - window_revisit,1]):moves_ind(i_move_back)-1)) > 0
                        new_price_bck =1; 
                    end
                    
                end
                
                temp_moves_fwd = find( moves_ind(j+1:end) <= moves_ind(j) + window_revisit,1,'first'); 
                
                if isempty(temp_moves_fwd) == 0
                   
                    
 
                   for k = temp_moves_fwd'
                       
                       reset_ind_newprice(moves_ind(j + k)) = pjs(moves_ind(j)) == pagg_temp(moves_ind(j)); 

                       revisit_ind_newprice(moves_ind(j +k))     = sum( pmax(moves_ind(j+k)) == pmax(max(moves_ind(j) - window_revisit_modalp,1):moves_ind(j)-1))  > 0; 
                       revisit_ind_newprice_unc(moves_ind(j +k)) = sum( pmax(moves_ind(j+k)) == pmax(max(moves_ind(j) - window_revisit_modalp,1):moves_ind(j + k)-1))  > 0; 
                   
                       if new_price_bck == 0
                          reset_ind_newprice2(moves_ind(j + k)) = pjs(moves_ind(j)) == pagg_temp(moves_ind(j)); 

                          revisit_ind_newprice2(moves_ind(j +k))     = sum( pmax(moves_ind(j+k)) == pmax(max(moves_ind(j) - window_revisit_modalp,1):moves_ind(j)-1))  > 0; 
                          revisit_ind_newprice_unc2(moves_ind(j +k)) = sum( pmax(moves_ind(j+k)) == pmax(max(moves_ind(j) - window_revisit_modalp,1):moves_ind(j + k)-1))  > 0; 
                       end
                   
                   end
                   
                    
                end
            end
        end
        
        if pmax(moves_ind(j)) > pmax(moves_ind(j)-1)
            revisit_ind_up(moves_ind(j)) = revisit_ind(moves_ind(j));
            j_up = j_up + 1;
        else
            revisit_ind_down(moves_ind(j)) = revisit_ind(moves_ind(j));
            j_down = j_down + 1;
        end
        
        mode_price = mode(pmax( max(moves_ind(j) - 6,1): min(moves_ind(j)+6, length(pmax))));
        mod_price2 = mode(pmax( max(moves_ind(j) - 13,1): min(moves_ind(j)-1, length(pmax))));
        mod_price3 = mode(pmax( max(moves_ind(j) - 12,1): min(moves_ind(j), length(pmax))));
        
        temp_window = pmax( max(moves_ind(j) -6,1): min(moves_ind(j)+6,length(pmax)));
        
        second_price = mode(temp_window(temp_window ~= mode_price));
        bounce_ind(moves_ind(j)) = (pmax(moves_ind(j)-1) == mode_price)*(pmax(moves_ind(j)) == second_price) + (pmax(moves_ind(j)-1) == second_price)*(pmax(moves_ind(j)) == mode_price);
        
        return_mod_ind(moves_ind(j)) = (pmax(moves_ind(j)) == mode_price);
        
        
        if moves_ind(j) > start_index(ii) + window_length - 1 & moves_ind(j) <= length(mod_price_temp) - window_length + 1
            
            if all(pmax(moves_ind(j)-1) ~= mod_price_temp(moves_ind(j)-13:moves_ind(j)-1))
                return_mod_ind2(moves_ind(j)) = (pmax(moves_ind(j)) == mode_price);
            end
            
        end
        
        %%%% Probability of revisiting as a function of N
        
        revisit_N(moves_ind(j)) = sum( pmax(moves_ind(j)) == pmax(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1));
        
        %%%% Probability of revisiting a price given relative N in window
        
        uniq_prices = unique(pmax(max(moves_ind(j) - window_revisit,1):moves_ind(j)-1));
    end
    
    for j = 2:length(movesmod_ind)
        
        
            revisit_ind_modprice(movesmod_ind(j)) = ( sum( mod_price_temp(movesmod_ind(j)) == mod_price_temp(max(movesmod_ind(j) - window_revisit_modalp,1):movesmod_ind(j)-1)) >0 );
        
    end
    
    revisit_ind_mat(start_index(ii):end_index(ii),firm_col_idx(ii)) = revisit_ind(start_index(ii):end_index(ii));
    
    revisit_ind_moddp_mat(start_index(ii):end_index(ii),firm_col_idx(ii)) = revisit_ind_moddp(start_index(ii):end_index(ii));

    %revisit_ind_regshift_mat(start_index(ii):end_index(ii),firm_col_idx(ii)) = revisit_ind_regshift(start_index(ii):end_index(ii));
    %revisit_ind_regshift_mat2(start_index(ii):end_index(ii),firm_col_idx(ii)) = revisit_ind_regshift2(start_index(ii):end_index(ii));
    
    revisit_ind_modprice_mat(start_index(ii):end_index(ii),firm_col_idx(ii))      = revisit_ind_modprice(start_index(ii):end_index(ii));
    %revisit_ind_modprice_mat2(start_index(ii):end_index(ii),firm_col_idx(ii))     = revisit_ind_modprice2(start_index(ii):end_index(ii));
    
    revisit_ind_newprice_mat(start_index(ii):end_index(ii),firm_col_idx(ii))           = revisit_ind_newprice(start_index(ii):end_index(ii));
    revisit_ind_newprice_unc_mat(start_index(ii):end_index(ii),firm_col_idx(ii))       = revisit_ind_newprice_unc(start_index(ii):end_index(ii));
    revisit_ind_newprice_mat2(start_index(ii):end_index(ii),firm_col_idx(ii))          = revisit_ind_newprice2(start_index(ii):end_index(ii));
    revisit_ind_newprice_unc_mat2(start_index(ii):end_index(ii),firm_col_idx(ii))      = revisit_ind_newprice_unc2(start_index(ii):end_index(ii));

    reset_ind_newprice_mat(start_index(ii):end_index(ii),firm_col_idx(ii))              = reset_ind_newprice(start_index(ii):end_index(ii));
    reset_ind_newprice_mat2(start_index(ii):end_index(ii),firm_col_idx(ii))             = reset_ind_newprice2(start_index(ii):end_index(ii));
    reset_ind_mat(start_index(ii):end_index(ii),firm_col_idx(ii))                       = reset_ind(start_index(ii):end_index(ii));;
    
    return_mod_ind_mat(start_index(ii):end_index(ii),firm_col_idx(ii)) = return_mod_ind(start_index(ii):end_index(ii));
    return_mod_ind_mat2(start_index(ii):end_index(ii),firm_col_idx(ii)) = return_mod_ind2(start_index(ii):end_index(ii));
    
    revisit_N_mat(start_index(ii):end_index(ii),firm_col_idx(ii)) = revisit_N(start_index(ii):end_index(ii));
    revisit_relN_mat(start_index(ii):end_index(ii),firm_col_idx(ii)) = revisit_relN(start_index(ii):end_index(ii));
    
end

%%

price_changes = abs(dp(abs(dp)>0));

%%%% Discreteness moment
window2 = 26;
pdp_ratio26  = NaN(T_sims, num_firms);
num_unique26 = NaN(T_sims, num_firms);
pdp_ratio26_nonstd = pdp_ratio26;

for ii = 1:num_firms_augm
    pmax_sims_ii = pmax_sims(:,firm_col_idx(ii));
    start_index_temp = start_index(ii);
    end_index_temp   = end_index(ii);
    
    num_unique26_temp = NaN(T_sims, 1);
    pdp_ratio26_temp  = NaN(T_sims, 1);
    min_temp          = NaN(T_sims, 1);
    
    for t = start_index_temp:end_index_temp - window2 + 1
        pmax_temp = pmax_sims_ii(t:t + window2 - 1);
        num_unique26_temp(t) = length(unique(pmax_temp));
        
        if sum( abs(diff(pmax_temp)) > 0) > 0
            pdp_ratio26_temp(t)  = length(unique(pmax_temp))/( sum( abs(diff(pmax_temp)) > 0) + 1);
            min_temp(t)          = 2/( sum( abs(diff(pmax_temp)) > 0) + 1);
        end
    end
    
    num_unique26(start_index(ii):end_index(ii)       ,firm_col_idx(ii)) = num_unique26_temp(start_index(ii):end_index(ii) );
    pdp_ratio26(start_index(ii):end_index(ii)        ,firm_col_idx(ii))  = ( pdp_ratio26_temp(start_index(ii):end_index(ii) ) - min_temp(start_index(ii):end_index(ii) ))./( 1 - min_temp(start_index(ii):end_index(ii) ) );
    pdp_ratio26_nonstd(start_index(ii):end_index(ii) ,firm_col_idx(ii)) = pdp_ratio26_temp(start_index(ii):end_index(ii) );
    
end


z_regs_lite_v3


zregs_tstats    = [    bz./std_z, bw./std_w, bz2./std_z2, bw2./std_w2,  bz3./std_z3, bw3./std_w3, bz4./std_z4, bw4./std_w4];
zw_effects      = [    (bz + b_int*nanmean(w_score1_reg_1(:)))*nanstd(z_score1_diff_reg_1(:)), (bw + b_int*nanmean(z_score1_diff_reg_1(:)))*nanstd(w_score1_reg_1(:)), ...
    (bz2 + b_int2*nanmean(w_score1_reg_2(:)))*nanstd(z_score1_diff_reg_2(:)), (bw2 + b_int2*nanmean(z_score1_diff_reg_2(:)))*nanstd(w_score1_reg_2(:)), ...
    (bz3 + b_int3*nanmean(w_score1_reg_3(:)))*nanstd(z_score1_diff_reg_3(:)), (bw3 + b_int3*nanmean(z_score1_diff_reg_3(:)))*nanstd(w_score1_reg_3(:)), ...
    (bz4 + b_int4*nanmean(w_score1_reg_4(:)))*nanstd(z_score1_diff_reg_4(:)), (bw4 + b_int4*nanmean(z_score1_diff_reg_4(:)))*nanstd(w_score1_reg_4(:))];

mean_Y = [nanmean(Y1); nanmean(Y2); nanmean(Y3); nanmean(Y4)];


%%
%%% Hazard -- linear probability model

new_firms_index = find(start_index > 1);


price_spell_age = NaN( T_sims, num_firms);
firm_age        = NaN( T_sims, num_firms);

time_index      = 1:T_sims;

for ii = new_firms_index
    
    spell_age_temp = NaN(T_sims,1);
    pmax_temp = pmax_sims(:,firm_col_idx(ii));
    
    for jj = start_index(ii)+1:end_index(ii)
        
        spell_age_temp(jj) = 1;
        
        for k = 2:jj-1
            
            ind = ( pmax_temp(jj-1) == pmax_temp(jj-k));
            
            if ind == 1
                spell_age_temp(jj) = spell_age_temp(jj) + ind;
            else
                break
            end
            
        end
        
    end
    
    price_spell_age(start_index(ii):end_index(ii),firm_col_idx(ii)) = spell_age_temp(start_index(ii):end_index(ii));
    firm_age(start_index(ii):end_index(ii),firm_col_idx(ii))    = 1:end_index(ii) - start_index(ii) + 1;
end

price_change_ind = NaN(size(pmax_sims));
temp = NaN(size(abs_dp));
temp(isfinite(abs_dp)) = abs_dp(isfinite(abs_dp)) > 0;
price_change_ind(2:end,:) = temp;


price_change_size   = NaN(size(pmax_sims));
price_change_size(2:end,:) = abs_dp;
price_change_size( price_change_size == 0) = NaN;

price_change_ind_newfirms = price_change_ind;
price_change_size_newfirms = price_change_size;
price_spell_age_newfirms   = price_spell_age;
firm_age_newfirms          = firm_age;

for ii = 1:num_firms
    price_change_ind_newfirms(start_index(ii):end_index(ii),firm_col_idx(ii))  = NaN;
    price_change_size_newfirms(start_index(ii):end_index(ii),firm_col_idx(ii)) = NaN;
    
    price_spell_age_newfirms(start_index(ii):end_index(ii),firm_col_idx(ii)) = NaN;
    firm_age_newfirms(start_index(ii):end_index(ii),firm_col_idx(ii))        = NaN;
end


haz_cutoff = 26;
[ bet1, ~, ~,~,~] = regress( price_change_ind_newfirms( price_spell_age_newfirms(:) <= haz_cutoff ), [ones(length(price_change_ind_newfirms(price_spell_age_newfirms(:) <= haz_cutoff)),1), price_spell_age_newfirms(price_spell_age_newfirms(:) <= haz_cutoff)]);

haz_slope = bet1(end);

%%%% Hazard: Eden-Campbell, cell-based young vs old approach


young_cell         = NaN(3,length(new_firms_index));
old_cell           = NaN(3,length(new_firms_index));
avg_age_youngcell  = NaN(3,length(new_firms_index));
avg_age_oldcell    = NaN(3,length(new_firms_index));
tstat_cell         = NaN(3, length(new_firms_index));

young_cell_exchg  = NaN(3, length(new_firms_index));
old_cell_exchg    = NaN(3, length(new_firms_index));

min_obs = 200;

for i = new_firms_index
    
    if end_index(i) - start_index(i) + 1 < min_obs
        continue
    end
    
    price_change_temp  = price_change_ind( start_index(i):end_index(i) , firm_col_idx(i));
    price_spell_temp   = price_spell_age( start_index(i):end_index(i) , firm_col_idx(i));
    price_change_size_temp = price_change_size( start_index(i):end_index(i) , firm_col_idx(i));
    
    young_cell(1,i - num_firms) = mean( price_change_temp( price_spell_temp <=4 ));
    old_cell(1,i - num_firms)   = mean( price_change_temp( price_spell_temp > 4 & price_spell_temp <=haz_cutoff ));
    
   
    avg_age_youngcell(1,i - num_firms) = nanmean(price_spell_temp(price_spell_temp <=4));
    avg_age_oldcell(1,i - num_firms) = nanmean(price_spell_temp(price_spell_temp>4 & price_spell_temp <=haz_cutoff));
    
    n_young    = sum(isfinite( pmax_sims( price_spell_temp <=4)));
    n_old      = sum(isfinite( pmax_sims( price_spell_temp >4 & price_spell_temp <=haz_cutoff)));
    
    lambda_hat = nanmean(price_change_temp);
    T = sum(isfinite(price_change_temp));
    
    s_young = sqrt( lambda_hat*(1-lambda_hat)) / (( 1 - (1-lambda_hat)^4)*sqrt(T));
    s_old = sqrt( lambda_hat*(1-lambda_hat)) / (((1-lambda_hat)^4)*sqrt(T));
    
    tstat_cell(1,i - num_firms ) = ( old_cell(1,i - num_firms ) - young_cell(1,i- num_firms) ) / sqrt( s_old^2/n_old + s_young^2/n_young);
    
    young_cell(2,i- num_firms) = mean( price_change_temp( price_spell_temp <=5 ));
    old_cell(2,i- num_firms)   = mean( price_change_temp( price_spell_temp >5 & price_spell_temp <=haz_cutoff));
    
    
    n_young    = sum(isfinite( pmax_sims( price_spell_temp <=5 )));
    n_old      = sum(isfinite( pmax_sims( price_spell_temp >5 & price_spell_temp <=haz_cutoff)));
    
    s_young = sqrt( lambda_hat*(1-lambda_hat)) / (( 1 - (1-lambda_hat)^5)*sqrt(T));
    s_old = sqrt( lambda_hat*(1-lambda_hat)) / (((1-lambda_hat)^5)*sqrt(T));
    
    tstat_cell(2,i- num_firms) = ( old_cell(2,i- num_firms) - young_cell(2,i- num_firms) ) / sqrt( s_old^2/n_old + s_young^2/n_young);
    
    young_cell(3,i- num_firms) = mean( price_change_temp( price_spell_temp <=6 ));
    old_cell(3,i- num_firms)   = mean( price_change_temp( price_spell_temp >6 & price_spell_temp <=haz_cutoff));
    
   
    
    n_young    = sum(isfinite( pmax_sims( price_spell_temp <=6 )));
    n_old      = sum(isfinite( pmax_sims( price_spell_temp >6 & price_spell_temp <=haz_cutoff)));
    
    s_young = sqrt( lambda_hat*(1-lambda_hat)) / (( 1 - (1-lambda_hat)^6)*sqrt(T));
    s_old = sqrt( lambda_hat*(1-lambda_hat)) / (((1-lambda_hat)^6)*sqrt(T));
    
    tstat_cell(3,i- num_firms) = ( old_cell(3,i- num_firms) - young_cell(3,i- num_firms) ) / sqrt( s_old^2/n_old + s_young^2/n_young);
    
end


hazard_diff_sig = sum( tstat_cell  < 1.96 ,2)./  sum(isfinite(tstat_cell),2);
diff_old_young =  [nanmean( old_cell - young_cell,2)];

col_headers = { 'young_4_200', 'young_5_200',	'young_6_200',	'old_4_200',	'old_5_200',	'old_6_200'};
temp =  [young_cell(1:3,:)', old_cell(1:3,:)'];
temp = temp(isfinite(temp(:,1)),:); 

writematrix( temp,'hazard_cells_n200.xlsx', 'Sheet', 1, 'Range','A2')
writecell( col_headers,'hazard_cells_n200.xlsx', 'Sheet', 1, 'Range','A1')

writematrix( dp(abs_dp(:)>0), 'dp_distribution_sim.xlsx')
%%
%%% Life-Cycle Regressions

[ bet_dp_tau26_52, ~, ~,~,~] = regress( price_change_ind_newfirms(firm_age_newfirms(:) <= 52), [ones(length(price_change_ind_newfirms(firm_age_newfirms(:) <= 52)),1), (firm_age_newfirms(firm_age_newfirms(:) <= 52) <= 26) ]);

[ bet_absdp_tau26_52, ~, ~,~,~] = regress( price_change_size_newfirms(firm_age_newfirms(:) <= 52), [ones(length(price_change_ind_newfirms(firm_age_newfirms(:) <= 52)),1), (firm_age_newfirms(firm_age_newfirms(:) <= 52) <= 26) ]);

life_cycl_betas = [bet_dp_tau26_52(end), bet_absdp_tau26_52(end)];


disp(' ');
disp(' --------------------------------')
disp([' Table II. Targeted moments -- Data vs model '])
disp(' --------------------------------')
disp(['                       '  ]);
disp( ' ');
disp([' (1) Frequency of regular price changes                  :' , sprintf('%1.3f  ', freq_dp)  ]);
disp([' (2) Median size of absolute regular price changes       :' , sprintf('%1.3f  ', dp_size)  ]);
disp([' (3) 75th percentile of non-zero absolute price chgs     :' , sprintf('%1.3f  ', prctile(price_changes, 75))  ]);
disp([' (4) Fraction of price changes that are increases        :' , sprintf('%1.3f  ', dp_incr_frac)  ]);
disp([' (5) Frequency of modal price changes                    :' , sprintf('%1.3f  ', freq_dp_mod) ]);
disp([' (6) Mean duration of price regime                       :' , sprintf('%1.3f  ',  mean(duration_vec))]);

disp(' ');
disp(' --------------------------------')
disp([' Table III. Untargeted moments -- Data vs model '])
disp(' --------------------------------')
disp(['                       '  ]);
disp( ' Panel A:');
disp([' (1) Probability modal price is the maximal price        :' , sprintf('%1.3f  ', nanmean(maxp_modal_ind(:))) ]);
disp([' (2) Fraction of time at modal price (in window)         :' , sprintf('%1.3f  ', nanmean(frac_at_modalp(:)))  ]);
disp([' (3) Probability price moves to modal price              :' , sprintf('%1.3f  ',  nanmean(return_mod_ind_mat2(:))) ]);
disp( ' Panel B:');
disp([' (4) Probability revisiting old price                    :' , sprintf('%1.3f  ', nanmean(revisit_ind_mat(:))) ]);
disp([' (5) uni: Mean # unique prices / ( # price changes + 1 ) :' , sprintf('%1.3f  ', nanmean(pdp_ratio26_nonstd(:)))]);
disp( ' Panel C:');
disp([' (6) Avg hazard slope                                    :' , sprintf('%1.3f  ', haz_slope)  ]);
disp( ' Panel D:');
disp([' (7)  Kurtosis                                           :' , sprintf('%1.3f  ', kurtosis(dp(abs(dp(:))>0))) ]);
disp([' (8)  Prob. modal price revists older modal price        :' , sprintf('%1.3f  ', nanmean(revisit_ind_modprice_mat(:))) ]);
disp([' (9)  Prob. revisit P from before last modal P chg       :' , sprintf('%1.3f  ', nanmean(revisit_ind_moddp_mat(:))) ]);
disp([' (10) Prob. revisit P from before brand new price        :' , sprintf('%1.3f  ', nanmean(revisit_ind_newprice_mat(:))) ]);
disp( ' Life-cycle regression');
disp([' (11) Differential freq. price chg in first 6m           :' , sprintf('%1.3f  ', life_cycl_betas(1)) ]);
disp([' (12) Differential abs size price chg in first 6m        :' , sprintf('%1.3f  ', life_cycl_betas(2)) ]);


disp(' ');
disp(' --------------------------------')
disp([' Table IV. Z-score regressions '])
disp(' --------------------------------')
disp(['                       '  ]);
disp( ' wscore_{ij,t-1} <= x                                       x=12     x=25'  );
disp([' (1) zscore_{ij,t-1} - zscore_{ij,t-1}^{lag}             :' , sprintf('%1.4f  ', zw_effects([1,3]) ) ]);
disp([' (2) wscore_{ij,t-1}                                     :' , sprintf('%1.4f  ', zw_effects([2,4]) ) ]);


