function VF_mat = cont_value_fun_fast( pref_grid, z_grid_gh, w_grid,r, p0, n0, qDemand0, beta_inv, params_CV, r_counter, sigmaxsqr_hat0)

pref_nodes = params_CV(1);
qref_nodes = params_CV(2);
w_nodes    = params_CV(3);
sigma_z    = params_CV(4);
psi        = params_CV(5);
sigma_x    = params_CV(6);
b          = params_CV(7);
pjs        = params_CV(8);
p_agg      = params_CV(9);
c_agg      = params_CV(10);
st         = params_CV(11);
at         = params_CV(12);
chi        = params_CV(13);

VF_mat         = NaN( qref_nodes, w_nodes, pref_nodes);

exp_r = exp(r + pjs - p_agg);
exp_c = chi*exp(st - p_agg - at - w_grid);

markup = bsxfun(@minus,exp_r, exp_c');

pos_markup_index = NaN(w_nodes,1);

for i = 1:w_nodes
    
    ind_temp = find(markup(i,:) >= 0,1);
    pos_markup_index(i) = ind_temp;
    markup(i,1:ind_temp-1) = 1e-11; 
end

%markup( markup <= 0 ) = 1e-11;
markup = log(markup);

p0 = p0(1:r_counter);
n0 = n0(1:r_counter);

Sigma12 = NaN(length(r), r_counter+1);
Kp0p1  = NaN(r_counter+1, r_counter+1);

for i = 1:r_counter
    
    %%% Squared exponential variance function -- alpha's might be negative!
    Sigma12(:,i) = (sigma_x^2*exp(-psi^2*(r - p0(i)).^2))';
    Kp0p1(1:r_counter,i) = sigma_x^2*exp(-psi^2*(p0 - p0(i)).^2);
    
end

%exp_sigmaz = exp(0.5*sigma_z^2 + b*(p_agg - pjs) + c_agg );

for i_p1 = 1:pref_nodes % this loops over the possible p1 prices the firm comes into the period with
    
    r1 = pref_grid(i_p1);   %%% observed price at period 1
    
    
    pU = [p0; r1];
    nt = [n0; 1];
    
    ySE    = sigma_z./sqrt(nt); %sorted standard-deviation for quantities
    
    np = length(pU);
    
    %%% Compute alpha -- the vector of weights for the signals
    
    Sigma12(:,end) = (sigma_x^2*exp(-psi^2*(r - r1).^2))';
    Kp0p1(:,end)   = sigma_x^2*exp(-psi^2*(pU - r1).^2);
    Kp0p1(end,:)   = sigma_x^2*exp(-psi^2*(pU - r1).^2);
    
    Sigma22 = Kp0p1 + diag(ones(np,1).*(ySE.^2));
    
    alpha = Sigma12/Sigma22;
    sigmaxsqr_hat = (sigma_x^2 - sum(alpha.*Sigma12,2))';
    
    alpha_end = alpha(:,end);
    
    
    gmax_t2_temp = NaN(qref_nodes, w_nodes);
    VF_temp      = NaN(qref_nodes, w_nodes);
    
    z_grid = sqrt(2)*sqrt(sigma_z^2 + sigmaxsqr_hat0(i_p1))*z_grid_gh;

    
    for i_y1 = 1:qref_nodes  % loops over the possible demand realizations the firm observed at P1
        
        qDemand = qDemand0 + (alpha_end*z_grid(i_y1))';
        %gmax_t2_temp = NaN(1,w_nodes); 
        
        for i_w = 1: w_nodes
            
            g = markup(i_w,:) + 0.5*(sigmaxsqr_hat) + qDemand;
                        
            g_max = g(pos_markup_index(i_w));
            
            for i_max = pos_markup_index(i_w)+1:length(g)
                
                if g(i_max) > g_max
                    g_max = g(i_max);
                end
                
            end
            
            gmax_t2_temp(i_y1, i_w) = exp(g_max + 0.5*sigma_z^2 + b*(p_agg - pjs) + c_agg );
            %gmax_t2_temp(i_w) = exp(g_max)*exp_sigmaz;

        end
        
        
        VF_temp(i_y1,:) = beta_inv*gmax_t2_temp(i_y1,:)';
        
    end
    
    VF_mat(:,:,i_p1) = VF_temp;
    
end

end




