
%%%
t = T_sims;
T_periods = min(500, round(T_sims/2));

uniq_prices   = NaN(100, num_firms, T_periods);
uniq_prices_N = NaN(100, num_firms, T_periods);
uniq_prices_Y = NaN(100, num_firms, T_periods);
uniq_prices_z = NaN(100, num_firms, T_periods);

uniq_pcount = NaN(num_firms,1);

tic
parfor ii = 1:num_firms
    
    uniq_prices_temp = NaN(100, T_periods); 
    uniq_pricesN_temp = NaN(100, T_periods);
    uniq_pricesY_temp = NaN(100, T_periods); 
    
    for j = 1:T_periods
        
        t = T_sims - T_periods + j;
        if isnan(rmax_sims(t,ii))
            continue
        end
        
        firms_ind1 = find(end_index >= t);
        firms_ind2 = find(start_index <= t);
        firms_ind  = intersect(firms_ind1, firms_ind2); 
        
        r_hist = rmax_sims(start_index(firms_ind(ii)):t, firm_col_idx(firms_ind(ii)));
        n_hist = ones(length(r_hist),1);
        y_hist = y_hist_sims(start_index(firms_ind(ii)):t, firm_col_idx(firms_ind(ii)));
                
        data  = [r_hist, y_hist, n_hist];
        data  = data(isfinite(data(:,1)),:);
        data  = sortrows(data); %sorted data for price and quantity
        unique_p  = unique(data(:,1));
        data_unique = NaN(length(unique_p),3);
        
        
        for i=1:length(unique_p)
            datat = data(data(:,1)==unique_p(i,1),:);
            nt    = sum(datat(:,3));
            avt   = sum(datat(:,2).*datat(:,3))/nt;
            data_unique(i,:) = [datat(1) avt nt];
            
        end
        
        data = data_unique;
        
        
        r_hist = data(:,1);
        y_hist = data(:,2);
        n_hist = data(:,3);

        
        uniq_prices_temp(1:length(r_hist),j)   = r_hist;
        uniq_pricesN_temp(1:length(n_hist),j)  = n_hist;
        uniq_pricesY_temp(1:length(y_hist),j)  = y_hist; 
        

    end
    
        uniq_prices(:,ii,:)   = uniq_prices_temp;
        uniq_prices_N(:,ii,:) = uniq_pricesN_temp;
        uniq_prices_Y(:,ii,:) = uniq_pricesY_temp;
        
end
toc


%%%

num_uniq_p = squeeze(sum(isfinite(uniq_prices)));

np_cutoff = 10;


typ_p_mat = NaN(np_cutoff, T_periods);
typ_n_mat = NaN(np_cutoff, T_periods);
typ_y_mat = NaN(np_cutoff, T_periods);

typ_p3_mat = NaN(np_cutoff, T_periods);
typ_n3_mat = NaN(np_cutoff, T_periods);
typ_y3_mat = NaN(np_cutoff, T_periods);

uniqp_num = NaN(T_periods,1);

for j = 1:T_periods
    t = T_sims - T_periods + j;
    
    temp_n = uniq_prices_N(:,:,j);
    temp_y = uniq_prices_Y(:,:,j);
    temp_z = uniq_prices_z(:,:,j);
    
    [max_n,max_ind] = sort(temp_n, 'descend');
    
    
    maxn_top   = NaN(np_cutoff, size(max_n,2));
    maxn_price = NaN(np_cutoff, size(max_n,2));
    maxn_y     = NaN(np_cutoff, size(max_n,2));
    maxn_z     = NaN(np_cutoff, size(max_n,2));
    
    for i = 1:size(max_n,2)
        
        if isnan(rmax_sims(t,i))
            continue
        end
        
        temp = max_n(isfinite(max_n(:,i)),i);
        maxn_top(1:min(np_cutoff,length(temp)),i) = temp(1:min(length(temp),np_cutoff));
        
        temp_ind = max_ind(isfinite(max_n(:,i)),i);
        maxn_price(1:min(np_cutoff,length(temp)),i) = uniq_prices( temp_ind(1:min(length(temp_ind),np_cutoff)),i,j);
        
        temp_ind = max_ind(isfinite(max_n(:,i)),i);
        maxn_y(1:min(np_cutoff,length(temp)),i) = uniq_prices_Y( temp_ind(1:min(length(temp_ind),np_cutoff)),i,j);
        
    end

    
    %%%%%%%% Ergodic Distribution of History
    typ_p_mat(:,j) = nanmedian(maxn_price,2);
    typ_n_mat(:,j) = nanmedian(maxn_top,2);
    typ_y_mat(:,j) = nanmedian(maxn_y,2);
    
    typ_p3_mat(:,j) = nanmean(maxn_price,2);
    typ_n3_mat(:,j) = nanmean(maxn_top,2);
    typ_y3_mat(:,j) = nanmean(maxn_y,2);
    
    temp_uniqpnum = sum(isfinite(uniq_prices(:,:,j)));
    temp_uniqpnum = temp_uniqpnum( temp_uniqpnum ~= 0);
    
    uniqp_num(j) = nanmean( temp_uniqpnum,2);
end



r_hist_erg = nanmean(typ_p3_mat,2);
y_hist_erg = nanmean(typ_y3_mat,2);
n_hist_erg = nanmean(typ_n3_mat,2);

r_hist_erg = r_hist_erg(1:round(nanmean(uniqp_num))); 
n_hist_erg = n_hist_erg(1:round(nanmean(uniqp_num))); 
y_hist_erg = y_hist_erg(1:round(nanmean(uniqp_num))); 

