

a_sims = NaN(T_sims + burn_in,1);
s_sims = NaN(T_sims + burn_in,1);

w_sims_calvo = NaN(size(eps_w_mat_temp)); 
w_sims_menuc =  NaN(size(eps_w_mat_temp)); 
w_sims_kb =  NaN(size(eps_w_mat_temp)); 
w_sims_kink =  NaN(size(eps_w_mat_temp)); 

w_sims_calvo(1,:) = eps_w_mat_temp(1,:);
w_sims_menuc(1,:) = eps_w_mat_temp(1,:);
w_sims_kb(1,:) = eps_w_mat_temp(1,:);
w_sims_kink(1,:) = eps_w_mat_temp(1,:); 

a_sims(1,:) = 1*eps_a_temp(1);
s_sims(1,:) = mu_s + eps_s_temp(1);

for ii = 1:num_firms
    
    for t = 2:T_sims + burn_in 
        
        w_sims_calvo(t,ii) = rho_w*w_sims_calvo(t-1,ii) + eps_w_mat_temp(t,ii);
        w_sims_menuc(t,ii) = rho_w*w_sims_menuc(t-1,ii) + eps_w_mat_temp(t,ii);
        w_sims_kb(t,ii)    = rho_w*w_sims_kb(t-1,ii)    + eps_w_mat_temp(t,ii);
        w_sims_kink(t,ii)  = rho_w*w_sims_kink(t-1,ii)  + eps_w_mat_temp(t,ii);
    end
    
    
end

for t = 2:T_sims + burn_in
    a_sims(t) = rho_a*a_sims(t-1) + eps_a_temp(t);
    s_sims(t) = mu_s + s_sims(t-1) + eps_s_temp(t);
end

p_agg_sims  = log((b/(b-1))*chi*exp(s_sims-a_sims + 0.5*(sigma_z^2/(1-b) + (1-b)*sigma_w^2)));
p_agg_sims0 = log((b/(b-1))*chi*exp(mu_s*(1:T_sims+burn_in)'-a_sims + 0.5*(sigma_z^2/(1-b) + (1-b)*sigma_w^2)));
c_agg_sims  = log(((b-1)/b)*(1/chi)*exp(a_sims - 0.5*(sigma_z^2/(1-b) + (1-b)*sigma_w^2)));

options_fsolve = optimset('fsolve');
options_fsolve.Display = 'off';
options_fsolve.MaxFunEvals = 185000;
options_fsolve.MaxIter = 5000;
options_fsolve.TolX = 1e-16;
options_fsolve.TolFun = 1e-19;
options_fsolve.DerivativeCheck = 'off';
options_fsolve.Jacobian = 'on';
options_fsolve.FinDiffType = 'center';

%%%
%%%
p_flex_calvo       = log(mu*chi) + (s_sims-a_sims- w_sims_calvo);
p_flex_menuc       = log(mu*chi) + (s_sims-a_sims- w_sims_menuc);
p_flex_kb          = log(mu*chi) + (s_sims-a_sims- w_sims_kb);
p_flex_kink        = log(mu*chi) + (s_sims-a_sims- w_sims_kink);

p_flex_s0              = log(mu*chi) + (mu_s*(1:T_sims+burn_in)' - a_sims - w_sims_calvo); 
p_flex_menuc0          = p_flex_s0; 
p_flex_kbs0            = log(mu*chi) + (mu_s*(1:T_sims+burn_in)' - a_sims - w_sims_kb);
p_flex_kinks0          = log(mu*chi) + (mu_s*(1:T_sims+burn_in)' - a_sims - w_sims_kink); 


p_calvo = NaN(size(p_flex_calvo));
p_menuc = p_calvo;
p_kimball = p_calvo; 
p_kink    = p_calvo; 

p_calvo0 = p_calvo; 
p_menuc0 = p_calvo; 
p_kimball0 = p_kimball; 
p_kink0    = p_calvo; 

pgap_calvo = p_calvo; 
pgap_menuc = p_calvo; 
pgap_kimball = p_calvo; 
pgap_kink    = p_calvo; 

pjs_sims = p_calvo; 
cjs_sims = p_calvo; 

pjs0_sims = p_calvo; 


tic
for ii = 1:num_firms
    p_temp    = NaN(T_sims + burn_in,1);
    pjs_temp  = p_temp; 
    pjs0_temp = p_temp;
    cjs_temp  = p_temp;

    p_temp(1) = p_flex_calvo(1,ii);   
    p_menuc_temp  = p_temp; 
    p_kimball_temp = p_temp; 
    p_kink_temp    = p_temp; 
    
    p_temp0    = NaN(size(p_temp)); 
    p_temp0(1) = p_flex_s0(1,ii);
    p_menuc_temp0 = p_temp0; 
    p_kimball_temp0 = p_temp0;  
    p_kink_temp0    = p_temp0; 
    
    kimball_obj = @(x) kimball_foc(x,p_agg_sims(1), veps, b, s_sims(1), a_sims(1), w_sims_kb(1,ii), chi);
    [p_kimball_target] = fixed_point_fast(kimball_obj, p_flex_kb(1,ii)); 
    p_kimball_target_lag = p_kimball_target; 
    
    p_kimball_temp(1) = min( p_kimball_target, p_agg_sims(1)  + 1/veps);
    
    
    kimball_obj0 = @(x) kimball_foc(x,p_agg_sims0(1), veps, b, mu_s, a_sims(1), w_sims_kb(1,ii), chi);
    [p_kimball_target0] = fixed_point_fast(kimball_obj0, p_flex_s0(1,ii)); 

    p_kimball_temp0(1) = min( p_kimball_target0, p_agg_sims0(1)  + 1/veps);

    
    pjs_temp(1)   =  p_agg_sims(1);
    cjs_temp(1)   =  c_agg_sims(1);

    pjs0_temp(1)   =  p_agg_sims0(1);
    
        
    for t = 2: T_sims + burn_in
       
        price_reg  = lambdaT_rand_mat(t,ii);

        pjs_temp(t)    =  p_agg_sims(t);
        pjs0_temp(t)   =  p_agg_sims0(t);
        
        cjs_temp(t)    =  c_agg_sims(t); 
        cjs_temp(t)    =  c_agg_sims(t);

        %%%%%% Calvo 
        if lambdaT_rand_mat(t,ii) <= calvo_freq

            
            p_temp(t)  = log(mu*chi) + (cjs_temp(t) + pjs_temp(t) - a_sims(t) - w_sims_calvo(t,ii));
            p_temp0(t) = log(mu*chi) + (cjs_temp(t) + pjs0_temp(t) - a_sims(t) - w_sims_calvo(t,ii));
            
        else
            p_temp(t) = p_temp(t-1);
            p_temp0(t) = p_temp0(t-1); 
        end
        
        pgap_calvo(t, ii) = p_flex_calvo(t,ii) - p_flex_calvo(t-1,ii); 
        
        p_flex_menuc(t,ii)     = log(mu*chi) + (cjs_temp(t) + pjs_temp(t) - a_sims(t) - w_sims_menuc(t,ii));
        p_flex_menuc0(t,ii)    = log(mu*chi) + (cjs_temp(t) + pjs0_temp(t) - a_sims(t) - w_sims_menuc(t,ii));
        %%%%%% Menu cost
        if  abs( p_flex_menuc(t,ii) - p_menuc_temp(t-1)) > menuc_threshold
            p_menuc_temp(t) = p_flex_menuc(t,ii);
        else
            p_menuc_temp(t) = p_menuc_temp(t-1);
        end
        
        if  abs( p_flex_menuc0(t,ii) - p_menuc_temp0(t-1)) > menuc_threshold
            p_menuc_temp0(t) = p_flex_menuc0(t,ii);
        else
            p_menuc_temp0(t) = p_menuc_temp0(t-1);
        end
        
        
        %%%%%% Menu cost   + Kimball Demand  
         
         kimball_obj = @(x) kimball_foc(x,p_agg_sims(t-1), veps, b, s_sims(t), a_sims(t), w_sims_kb(t,ii), chi);
        [p_kimball_target] = fixed_point_fast(kimball_obj, mean([p_kimball_temp(t-1), pjs_temp(t), p_flex_kb(t,ii)])); 
        pgap_kimball(t,ii) = p_kimball_target - p_kimball_target_lag; 
        p_kimball_target_lag = p_kimball_target; 
        
        p_kimball_target = min( p_kimball_target, pjs_temp(t)  + 1/veps);

         kimball_obj0 = @(x) kimball_foc(x,p_agg_sims0(t-1), veps, b, mu_s*t, a_sims(t), w_sims_kb(t,ii), chi);
        [p_kimball_target0] = fixed_point_fast(kimball_obj0, mean([p_kimball_temp0(t-1), pjs0_temp(t), p_flex_kb(t,ii)])); 
         p_kimball_target0 = min( p_kimball_target0, pjs0_temp(t)  + 1/veps);

        %%%%%% Menu cost + kimball demand
        if abs( p_flex_kb(t,ii) - p_kimball_temp(t-1)) > 0*kb_menuc_threshold/2
            if  abs( p_kimball_target - p_kimball_temp(t-1)) > kb_menuc_threshold
                p_kimball_temp(t) = p_kimball_target;
            else
                p_kimball_temp(t) = p_kimball_temp(t-1);
            end
        else
            p_kimball_temp(t) = p_kimball_temp(t-1);
        end

        if abs( p_flex_kbs0(t,ii) - p_kimball_temp0(t-1)) > 0*kb_menuc_threshold/2
            if  abs( p_kimball_target0 - p_kimball_temp0(t-1)) > kb_menuc_threshold
                p_kimball_temp0(t) = p_kimball_target0;
            else
                p_kimball_temp0(t) = p_kimball_temp0(t-1);
            end
        else
            p_kimball_temp0(t) = p_kimball_temp0(t-1);
        end

    end
    
    p_calvo(:,ii)   = p_temp;
    p_menuc(:,ii)   = p_menuc_temp;
    p_kimball(:,ii) = p_kimball_temp; 
    
    p_calvo0(:,ii)   = p_temp0;
    p_menuc0(:,ii)   = p_menuc_temp0;
    p_kimball0(:,ii) = p_kimball_temp0; 
    
    pjs_sims(:,ii)   = pjs_temp; 
    pjs0_sims(:,ii)  = pjs0_temp; 
    cjs_sims(:,ii)   = cjs_temp; 

    ii;
end
toc

p_kimball_imag = imag(p_kimball); 
if max( abs(p_kimball_imag(:))) > 1e-6
    error( 'imaginary solution to kimball prices')
end

p_kimball = real(p_kimball); 

dp_calvo = diff(p_calvo);
dp_menuc  = diff(p_menuc);
dp_kimball = diff(p_kimball); 

abs_dp_menuc   = abs(dp_menuc); 
abs_dp_calvo   = abs(dp_calvo); 
abs_dp_kimball = abs(dp_kimball); 

p_agg_sims = log((b/(b-1))*chi*exp(s_sims-a_sims + 0.5*(sigma_z^2/(1-b) + (1-b)*sigma_w^2)));
c_agg_sims = log(((b-1)/b)*(1/chi)*exp(a_sims - 0.5*(sigma_z^2/(1-b) + (1-b)*sigma_w^2)));

p_agg_sims = p_agg_sims(:,1);
c_agg_sims = c_agg_sims(:,1);


%%%%%%%%%%%%%%%%%% Prices
pjt_calvo       = 1/(1-b)*(.5*sigma_z^2+log(mean(exp((1-b)*p_calvo),2)));
pjt_menuc       = 1/(1-b)*(.5*sigma_z^2+log(mean(exp((1-b)*p_menuc),2)));

pjt_kb_obj      = @(x) kimball_pt_fixedpoint(x, p_kimball, veps, b, num_firms);
pjt_kimball     = fsolve( pjt_kb_obj, p_agg_sims, options_fsolve);

pjt_calvo0       = 1/(1-b)*(.5*sigma_z^2+log(mean(exp((1-b)*p_calvo0),2)));
pjt_menuc0       = 1/(1-b)*(.5*sigma_z^2+log(mean(exp((1-b)*p_menuc0),2)));

pjt_kb_obj0      = @(x) kimball_pt_fixedpoint(x, p_kimball0, veps, b, num_firms);
pjt_kimball0     = fsolve( pjt_kb_obj0, p_agg_sims0, options_fsolve);


%%%
%%%%%%%%%%%%%%%%%% First-order accurate price index 
pjt_calvo_approx = mean(p_calvo,2); 

%%%%% Alternative computation of quantities
yjt_calvo         = c_agg_sims + b*(p_agg_sims - pjt_calvo);
yjt_menuc         = c_agg_sims + b*(p_agg_sims - pjt_menuc);
yjt_kimball       = c_agg_sims + b*(p_agg_sims - pjt_kimball);

yjt_calvo0         = c_agg_sims + b*(p_agg_sims0 - pjt_calvo0);
yjt_menuc0         = c_agg_sims + b*(p_agg_sims0 - pjt_menuc0);
yjt_kimball0       = c_agg_sims + b*(p_agg_sims0 - pjt_kimball0);


