%%%%%%% Choice of score window size

score_window = 26;
% score_window = 20;
% score_window = 0;


burn         = 0;

%%%%%%%% Select which price series you want to analyze -- either
%%%% i)  rmax_sims (relative prices)
%%%% ii) pmax_sims (nominal prices)
price_series = pmax_sims;
% price_series = rmax_sims;
% dp  = dp_rmax; 

% markup=(pmax_sims+w_sims+a_sims)-log(b*chi/(b-1))-s_sims;
%     p_star = log(mu*chi) + (s_sims(t)-a_sims(t)- w_sims(t));
% p_flex_sims=pmax_sims-markup;
% markup_mc=(pmax_menuc_sims+w_sims)-log(b*chi/(b-1))-s_sims;

%dp = diff(price_series);
%dp( isfinite(dp) ) = abs(dp( isfinite(dp) )) > 0;

dp_ind = dp; 
dp_ind( isfinite(dp)) = abs(dp( isfinite(dp) )) > 0;

ind_price_change = NaN(size(price_series));
ind_price_change(2:end,:) = dp_ind;

%abs_dp = abs(diff(price_series));
% abs_delta_flex = abs(pmax_sims - p_flex_sims);

%%%%%%%%%%%%%%%%%%%%%%%%%% Choice of Y variable;
fixed_effects           = 0;
y_var                   = 0; % this applies only for the moving away regression 0: for dummy, 1: for abs(price change), 2: for abs(price change), no zeros,
%for the slides this equals to 2 may have been used
zvar_ind                = 1; % 1: z_sims, 2: zhat (regression estimate)

winsorise               = 0; %1 to remove 99-th and 1-th percentile, 0 to use all data
just_intensive          = 0; %1 to use only non-zero observations in the 'moving to' intensive margin regression; 0 to use zeros too
ext_revisit_set_w       = 1; %applies to probability of moving to any old price; 1: include w scores; 0: do not include w-scores
interaction             = 1; %0 if no other terms than z-score; 1 if w-score; 2 is also interaction terms
w_quantile              = 0; %operates only if interaction = 0; 0 if no w-score threshold; otherwise equal to the bottom x decile
below_above             = 1; %operates only if w_quantile>0; 1 if threshold refers to being below it; -1 if being above it
z_normalization         = 0;% 0 if no normalization of z-score; 1 if normalized by sqrt(w_score);
condition_price_changes = 1;
condition_w             = 1;
low_bound_w             = 1;
high_bound_w            = 12;
high_bound_w2           = 25; 

y = NaN(size(price_series));




if y_var == 0
    
    y(2:end,:) = dp_ind;
    
elseif y_var == 1
    
    temp = abs_dp;
    y(2:end,:) = temp;
    
elseif y_var ==2
    
    temp = abs_dp;
    temp(abs_dp == 0) = NaN;  %%%%% condition on only positive price changes
    y(2:end,:) = temp;
elseif y_var==3
    y(2:end,:) = abs_delta_flex(2:end,:);
    
elseif y_var==4
    temp = abs_delta_flex(2:end,:);
    temp(abs_dp == 0) = NaN;  %%%%% condition on only positive price changes
    y(2:end,:) = temp;
    % elseif y_var==5
    %     y(2:end,:) = abs(markup(2:end,:));
    %     elseif y_var==6
    %      temp = abs(markup(2:end,:));
    %     temp(abs_dp == 0) = NaN;  %%%%% condition on only positive price changes
    %     y(2:end,:) = temp;
    
    
end


%%%%%%%%%%%%%%%%%%%%%%%%%%% Compuations:

%%% Compute needed score variables


reset_observed = 1; %%% 1 if reset shocks observed, 0 if not observed
if reset_observed==1
    beta_z = 1 - lam_phi;
    beta_w = 1 - lam_phi;
else
    beta_z = 1 - phi;
    beta_w = 1 - phi;
end

beta_z = 1; 
beta_w = 1; 

beta_z = bsxfun(@power, beta_z, [score_window:-1:1]);
beta_w = bsxfun(@power, beta_w, [score_window:-1:1]);

z_score1 = NaN(T_sims, num_firms);
w_score1 = z_score1;

z_score2 = NaN(T_sims, num_firms);
w_score2 = z_score2;

z_score4 = NaN(T_sims, num_firms); %%% this will be used for "changes in z" regressions
w_score4 = NaN(T_sims, num_firms);

y_dist = NaN(T_sims, num_firms);
y_wdist = NaN(T_sims, num_firms);

zhat    = NaN(T_sims, num_firms);

p_agg_sims = log((b/(b-1))*chi*exp(s_sims-a_sims + 0.5*(sigma_z^2/(1-b) + (1-b)*sigma_w^2)));
c_agg_sims = log(((b-1)/b)*(1/chi)*exp(a_sims - 0.5*(sigma_z^2/(1-b) + (1-b)*sigma_w^2)));
p_agg_sims = p_agg_sims(end-T_sims+1:end,1);
c_agg_sims = c_agg_sims(end-T_sims+1:end,1);

dist_closestp = NaN(T_sims, num_firms);
z_score3      = z_score1;
w_score3      = w_score1;

z_score3_z      = z_score1;
w_score3_w      = w_score1;
z_score3_w      = z_score1;
w_score3_z      = w_score1;

w_score_max     = w_score1;

revisit_ind    = NaN(T_sims, num_firms);

revisit_ind_z    = NaN(T_sims, num_firms);

revisit_ind_w    = NaN(T_sims, num_firms);

dum_moveto_set=NaN(T_sims, num_firms);
dum_moveto_old=NaN(T_sims, num_firms);

sample_use  = zeros(T_sims, num_firms);
sample_use2  = zeros(T_sims, num_firms);
sample_use3  = zeros(T_sims, num_firms);
sample_use4  = zeros(T_sims, num_firms);



%%%% Pool together to compute z_hats
%{
for ii = 1:num_firms
    
    temp_y = y_hist_sims + repmat(c_agg_sims, 1, num_firms);
    pmax_zhat = pmax_sims(:);
    [btemp, bint, r, ~, ~] = regress( temp_y(2:end), [ones(length(temp_y(2:end)),1), temp_y(1:end-1), pmax_sims(2:size(pmax_sims,1),ii), p_agg_sims(2:end)]);
    
end
%}

for ii = 1:num_firms_augm
    
    
    temp_y = y_hist_sims(:,firm_col_idx(ii)) + c_agg_sims(:);
    temp_y([1:start_index(ii)-1, end_index(ii)+1:T_sims]) = NaN; 
    
    if sum(isfinite(temp_y)) < 5
        continue
    end
    
    z_var = NaN;
    
    if zvar_ind == 1
        
        z_var = z_sims(:,firm_col_idx(ii));
        z_var([1:start_index(ii)-1, end_index(ii)+1:T_sims]) = NaN; 

    elseif zvar_ind == 2
        
        if sum(isfinite(temp_y(2:end))) < 20
            continue
        end
        
        if sum( abs(diff(pmax_sims(2:size(pmax_sims,1),ii))) > 0 ) < 1
            
            [btemp, bint, r, ~, ~] = regress( temp_y(2:end), [ones(length(temp_y(2:end)),1), temp_y(1:end-1), p_agg_sims(2:end)]);
            zhat(:,ii) = [NaN; r];
            
        else
            
            [btemp, bint, r, ~, ~] = regress( temp_y(2:end), [ones(length(temp_y(2:end)),1), temp_y(1:end-1), pmax_sims(2:size(pmax_sims,1),firm_col_idx(ii)), p_agg_sims(2:end)]);
            zhat(:,ii) = [NaN; r];
        end
        
        z_var = zhat(:,ii);
    end
    
    for t = start_index(ii) + burn + score_window :end_index(ii)
        
        
        valid2 = ( price_series(t-score_window : t-1 , firm_col_idx(ii) ) == price_series(t, firm_col_idx(ii)) );
        
        if sum(valid2) == 0
            z_score2(t   , firm_col_idx(ii)) = 0;
            w_score2(t   , firm_col_idx(ii)) = sum( beta_w'.*valid2);
            
            z_score1(t   , firm_col_idx(ii)) = z_var(t);
            w_score1(t   , firm_col_idx(ii)) = w_score2(t, firm_col_idx(ii)) + 1;
            
        else
            %z_score2(t   ,ii) = sum( z_sims(t-score_window :t-1,ii).*beta_z'.*valid2)/sum(valid2);
            %w_score2(t   ,ii) = sum( beta_w'.*valid2);
            if z_normalization==1
                z_score2(t   , firm_col_idx(ii)) = (sum( z_var(t-score_window :t-1).*beta_z'.*valid2)/sum(valid2)).*sqrt(sum(valid2));
            else
                z_score2(t   , firm_col_idx(ii)) = (sum( z_var(t-score_window :t-1).*beta_z'.*valid2)/sum(valid2));
            end
            w_score2(t   , firm_col_idx(ii)) = sum( beta_w'.*valid2);
            
            %z_score1(t   ,ii) = (z_score2(t, ii)*sum(valid2) + z_sims(t,ii))/( sum(valid2) + 1);
            %w_score1(t   ,ii) =  w_score2(t, ii) + 1;
            if z_normalization==1
                %                 z_score1(t   ,ii) = ((z_score2(t, ii)*sum(valid2) + z_var(t))/( sum(valid2) + 1)).*sqrt(sum(valid2)+1);
                z_score1(t   , firm_col_idx(ii)) = ((z_score2(t, firm_col_idx(ii))*sum(valid2)/sqrt(sum(valid2)) + z_var(t))/( sum(valid2) + 1)).*sqrt(sum(valid2)+1);
            else
                z_score1(t   , firm_col_idx(ii)) = ((z_score2(t, firm_col_idx(ii))*sum(valid2) + z_var(t))/( sum(valid2) + 1));
                
            end
            w_score1(t   , firm_col_idx(ii)) =  w_score2(t, firm_col_idx(ii)) + 1;
        end
        
        %%% Changes in scores
        
%         valid4 = price_series(t - score_window:t,ii) == price_series(t,ii);
%         valid_counter = 0;
%         for j_valid = 1:score_window
%             
%             if valid4(j_valid) == 0
%                 break
%             else
%                 valid_counter = valid_counter + 1;
%             end
%             
%         end
%         
%         %z_score4(t,ii) = mean(z_var(t - valid_counter: t));
%         z_score4(t,ii) = z_score2(t - valid_counter,ii);     %%% z_score2 at time of first post
%         w_score4(t,ii) = valid_counter + 1;
%         
%         %%%% Probability of revisiting the last different price you were at
%         
%         if price_series(t, ii) ~= price_series(t-1, ii)
%             
%             dum_moveto_set(t,ii)=0;
%             dum_moveto_old(t,ii)=0;
%             
%             %             ind = find( diff(price_series(t - score_window : t-1,ii)), 1, 'last');
%             
%             
%             ind = find( diff(price_series(t - score_window : t-1,ii)));
%             
%             
%             %                         ind = find( diff(price_series(t - score_window : t,ii)));
%             
%             %             last_price = price_series( t - score_window + ind - 1, ii);
%             last_prices = price_series( t - score_window + ind - 1, ii);
%             z_score_revisit=nan(length(last_prices),1);
%             w_score_revisit=nan(length(last_prices),1);
%             revisit_ind_temp=nan(length(last_prices),1);
%             if isempty(last_prices) == 0
%                 for j=1:length(last_prices)
%                     last_price=last_prices(j);
%                     
%                     %revisit_ind(t,ii) = ( price_series(t, ii) == last_price);
%                     %                 revisit_ind(t,ii) = abs( price_series(t, ii) - last_price);
%                     revisit_ind_temp(j) = abs( price_series(t, ii) - last_price);
%                     %revisit_ind_temp(j) = ( price_series(t, ii) ==  last_price);
%                     
%                     valid_temp = ( price_series(t-score_window : t-1 , ii ) == last_price ) ;
%                     
%                     
%                     %                 z_score3(t, ii) = (sum( z_var(t-score_window :t-1).*beta_z'.*valid_temp)/sum(valid_temp)).*sqrt(sum(valid_temp));
%                     %                 w_score3(t, ii) = sum( beta_w'.*valid_temp);
%                     
%                     if z_normalization==1
%                         z_score_revisit(j) = (sum( z_var(t-score_window :t-1).*beta_z'.*valid_temp)/sum(valid_temp)).*sqrt(sum(valid_temp));
%                     else
%                         z_score_revisit(j) = (sum( z_var(t-score_window :t-1).*beta_z'.*valid_temp)/sum(valid_temp));
%                     end
%                     
%                     w_score_revisit(j) = sum( beta_w'.*valid_temp);
%                     
%                     if price_series(t, ii)==last_price
%                         dum_moveto_set(t,ii)=1;
%                     end
%                     
%                     if price_series(t, ii)==last_prices(end)
%                         dum_moveto_old(t,ii)=1;
%                     end
%                     
%                     
%                 end
%                 
%                 %this finds the max z-score and its associated distance and
%                 %w-score
%                 [z_score3_z(t,ii),kz] = max(z_score_revisit);
%                 w_score3_z(t,ii) =w_score_revisit(kz);
%                 revisit_ind_z(t,ii) = revisit_ind_temp(kz);
%                 
%                 %this finds the max w-score and its associated distance and z-score
%                 [w_score3_w(t,ii),kw] = max(w_score_revisit);
%                 z_score3_w(t,ii) =z_score_revisit(kw);
%                 revisit_ind_w(t,ii) = revisit_ind_temp(kw);
%                 
%                 %this uses the last different price to find its associated distance, z-score and w-score
%                 z_score3(t,ii) = z_score_revisit(end);
%                 w_score3(t,ii) = w_score_revisit(end);
%                 revisit_ind(t,ii) = revisit_ind_temp(end);
%                 
%                 
%             else
%                 %VERY CAREFUL HERE: here we make the w-scores and z-score
%                 %of the alternate highest w- and z-score prices be equal to
%                 %zero if there is no alternative price that is different
%                 %than P_t-1 in teh window
%                 w_score3_w(t,ii) =0;
%                 z_score3_z(t,ii) =0;
%                 z_score3(t,ii) = 0;
%                 w_score3(t,ii)=0;
%                 
%             end
%             
%             
%         end

%XXXXXXXXXXXXXXXXXXXXX
        
        w_score_max(t, firm_col_idx(ii))=max(w_score2(t-score_window : t-1,firm_col_idx(ii)));
        
        
        if w_score1(t,firm_col_idx(ii))>=low_bound_w&&w_score1(t,firm_col_idx(ii))<=high_bound_w&&price_series(t, firm_col_idx(ii)) == price_series(t-1, firm_col_idx(ii))
                
                %              if w_score1(t,ii)>=low_bound_w&&w_score1(t,ii)<=high_bound_w&&price_series(t, ii) == price_series(t-1, ii)&&price_series(t-1, ii)==price_series(t-2, ii)&&price_series(t-2, ii)==price_series(t-3, ii)
                
                %            if w_score1(t,ii)>=low_bound_w&&w_score1(t,ii)<=high_bound_w&&price_series(t, ii) == price_series(t-1, ii)
                
                sample_use(t,firm_col_idx(ii))=1;
        end
        
        if w_score1(t,firm_col_idx(ii))>=low_bound_w&&w_score1(t,firm_col_idx(ii))<=high_bound_w2&&price_series(t, firm_col_idx(ii)) == price_series(t-1, firm_col_idx(ii))
                
                %              if w_score1(t,ii)>=low_bound_w&&w_score1(t,ii)<=high_bound_w&&price_series(t, ii) == price_series(t-1, ii)&&price_series(t-1, ii)==price_series(t-2, ii)&&price_series(t-2, ii)==price_series(t-3, ii)
                
                %            if w_score1(t,ii)>=low_bound_w&&w_score1(t,ii)<=high_bound_w&&price_series(t, ii) == price_series(t-1, ii)
                
               sample_use2(t,firm_col_idx(ii))=1;
        end
        
        if w_score1(t,firm_col_idx(ii))>=low_bound_w&&w_score1(t,firm_col_idx(ii))<=high_bound_w
                
                %              if w_score1(t,ii)>=low_bound_w&&w_score1(t,ii)<=high_bound_w&&price_series(t, ii) == price_series(t-1, ii)&&price_series(t-1, ii)==price_series(t-2, ii)&&price_series(t-2, ii)==price_series(t-3, ii)
                
                %            if w_score1(t,ii)>=low_bound_w&&w_score1(t,ii)<=high_bound_w&&price_series(t, ii) == price_series(t-1, ii)
                
                sample_use3(t,firm_col_idx(ii))=1;
        end
        
        if w_score1(t,firm_col_idx(ii))>=low_bound_w&&w_score1(t,firm_col_idx(ii))<=high_bound_w2
                
                %              if w_score1(t,ii)>=low_bound_w&&w_score1(t,ii)<=high_bound_w&&price_series(t, ii) == price_series(t-1, ii)&&price_series(t-1, ii)==price_series(t-2, ii)&&price_series(t-2, ii)==price_series(t-3, ii)
                
                %            if w_score1(t,ii)>=low_bound_w&&w_score1(t,ii)<=high_bound_w&&price_series(t, ii) == price_series(t-1, ii)
                
               sample_use4(t,firm_col_idx(ii))=1;
        end
        
        
        ii;
    end
    
end



%%
%%% panel regressions

Y = NaN(length(y(:,1)), num_firms);
%Y = Y(2:end,:);

z_score1_diff_reg = NaN(size(Y)); 
w_score1_reg      = NaN(size(Y)); 
w_score1_reg2     = NaN(size(Y)); 

for i = 1:num_firms_augm
    
    
    Y(start_index(i):end_index(i)-1,firm_col_idx(i)) = y(start_index(i)+1:end_index(i),firm_col_idx(i));
    z_score1_diff_reg(start_index(i):end_index(i)-1,firm_col_idx(i)) = z_score1(start_index(i):end_index(i)-1,firm_col_idx(i)) - z_score2(start_index(i):end_index(i)-1,firm_col_idx(i)); 
    w_score1_reg(start_index(i):end_index(i)-1,firm_col_idx(i)) = w_score1(start_index(i):end_index(i)-1,firm_col_idx(i));
    w_score1_reg2(start_index(i):end_index(i)-1,firm_col_idx(i)) = w_score1(start_index(i):end_index(i)-1,firm_col_idx(i));
end

Y1 = Y; 
Y2 = Y; 
Y3 = Y; 
Y4 = Y; 

Y1( sample_use  == 0) = NaN;
Y2( sample_use2 == 0) = NaN;
Y3( sample_use3 == 0) = NaN;
Y4( sample_use4 == 0) = NaN;

%z_score1_reg = z_score1(1:end-1,:);
%w_score1_reg = w_score1(1:end-1,:);

%z_score1_diff_reg = z_score1(1:end-1,:) - z_score2(1:end-1,:);
%w_score1_reg2 = w_score1(1:end-1,:);
%w_score1_reg3 = w_score1(1:end-1,:);

%z_score1_change_reg =z_score2(2:end,:)-z_score1(1:end-1,:);


%w_score3_w_reg1 = w_score3_w(2:end,:);
%z_score3_z_reg1 = z_score3_z(2:end,:);
%z_score3_reg1 = z_score3(2:end,:);
%w_score3_reg1 = w_score3(2:end,:);

%w_score_max_reg2 = w_score_max(2:end,:);
%w_score_max_reg4 = w_score_max(2:end,:);


%z_score2_reg1 = z_score2(2:end,:);
%w_score2_reg1 = w_score2(2:end,:);

%z_score4_reg = z_score4(1:end-1,:);
%z_score4_reg  = z_score1(1:end-1,:) - z_score4(1:end-1,:); %%%% Change in z-score over time
%w_score4_reg  = w_score4(1:end-1,:);
%w_score1_reg4  = w_score1(1:end-1,:);

%z_score2_reg_revisit_set = z_score2(2:end,:);
%w_score2_reg_revisit_set = w_score2(2:end,:);

%     sample_no_pricechanges_1_reg= sample_no_pricechanges(2:end,:);
%     sample_no_pricechanges_2_reg= sample_no_pricechanges(2:end,:);
%     sample_no_pricechanges_3_reg= sample_no_pricechanges(2:end,:);





finite_idx1 = isfinite(Y1.*z_score1_diff_reg.*w_score1_reg2);

Y1 = Y1(finite_idx1);
z_score1_diff_reg_1  = z_score1_diff_reg(finite_idx1);
w_score1_reg_1  = w_score1_reg2(finite_idx1);
% w_score_max_reg_1 = w_score_max_reg2(finite_idx1);


%%%
finite_idx2 = isfinite(Y2.*z_score1_diff_reg.*w_score1_reg2);

Y2= Y2(finite_idx2);
z_score1_diff_reg_2  = z_score1_diff_reg(finite_idx2);
w_score1_reg_2  = w_score1_reg2(finite_idx2);
% w_score_max_reg_2 = w_score_max_reg2(finite_idx2);

finite_idx3 = isfinite(Y3.*z_score1_diff_reg.*w_score1_reg2);

Y3= Y3(finite_idx3);
z_score1_diff_reg_3  = z_score1_diff_reg(finite_idx3);
w_score1_reg_3  = w_score1_reg2(finite_idx3);
% w_score_max_reg_3 = w_score_max_reg2(finite_idx3);

finite_idx4 = isfinite(Y4.*z_score1_diff_reg.*w_score1_reg2);


Y4= Y4(finite_idx4);
z_score1_diff_reg_4  = z_score1_diff_reg(finite_idx4);
w_score1_reg_4  = w_score1_reg2(finite_idx4);
% w_score_max_reg_4 = w_score_max_reg2(finite_idx4);


%%

[breg, int,~,~,~] = regress( Y1, [ones(length(Y1),1), z_score1_diff_reg_1, w_score1_reg_1]);
bz = breg(end-1);
bw = breg(end);
b_int= 0;

std_z = (int(end-1,2) - bz)/1.96;
std_w = ( int(end,2) - bw )/1.96;
std_int = 0;
bz_dummy=0;
std_z_dummy=0;


[breg, int, ~,~,~] = regress( Y2, [ones(length(Y2),1), z_score1_diff_reg_2, w_score1_reg_2]);
bz2 = breg(end-1);
bw2 = breg(end);
b_int2= 0;

std_z2 = (int(end-1,2) - bz2)/1.96;
std_w2 = ( int(end,2) - bw2 )/1.96;
std_int2 = 0;
bz2_dummy=0;
std_z2_dummy=0;

[breg, int, ~,~,~] = regress( Y3, [ones(length(Y3),1), z_score1_diff_reg_3, w_score1_reg_3]);
bz3 = breg(end-1);
bw3 = breg(end);
b_int3= 0;

std_z3 = (int(end-1,2) - bz3)/1.96;
std_w3 = ( int(end,2) - bw3 )/1.96;
std_int3 = 0;
bz3_dummy=0;
std_z3_dummy=0;

[breg, int, ~,~,~] = regress( Y4, [ones(length(Y4),1), z_score1_diff_reg_4, w_score1_reg_4]);
bz4 = breg(end-1);
bw4 = breg(end);
b_int4= 0;

std_z4 = (int(end-1,2) - bz4)/1.96;
std_w4 = ( int(end,2) - bw4 )/1.96;
std_int4 = 0;
bz4_dummy=0;
std_z4_dummy=0;
 

%% Cost shock elasticity

dp_ind = diff(pmax_sims_orig(burn_in+1:end,:)); 
dp_ind( isfinite(dp_ind) ) = abs( dp_ind( isfinite( dp_ind )))>0; 

idx_temp = lambdaPhi_rand_mat(2:end,:) <= lam_phi; 

dp_ind( idx_temp == 1) = NaN; 
w_sims2  = diff(w_sims(burn_in+1:end,:)); 
eps_w_mat2 = eps_w_mat_temp(burn_in + 2:end,:); 

%finite_idx5 = isfinite( dp_ind.*w_sims2(2:end,:));
%dp_ind  = dp_ind(finite_idx5);

[breg, int, ~,~,~] = regress( dp_ind(:), [ones(length(dp_ind(:)),1), abs( w_sims2(:))]);

bet_dp_absw = breg(2); 

[breg, int, ~,~,~] = regress( dp_ind(:), [ones(length(dp_ind(:)),1), abs( eps_w_mat2(:))]);

bet_dp_absepsw = breg(2); 

clear w_sism2 eps_w_mat2 z_score1_diff_reg1 z_score1_diff_reg2 z_score1_diff_reg3 z_score1_diff_reg4 w_score1_reg1 w_score1_reg2 w_score1_reg3 w_score1_reg4
return
%%

[breg, int,~,~,~] = regress( Y1, [ones(length(Y1),1), z_score1_diff_reg_1, w_score1_reg_1, abs(z_score1_diff_reg_1)]);
bz = breg(2);
bw = breg(3);
bzabs = breg(4);
b_int= 0;

std_z = (int(end-1,2) - bz)/1.96;
std_w = ( int(end,2) - bw )/1.96;
std_int = 0;
bz_dummy=0;
std_z_dummy=0;


[breg, int, ~,~,~] = regress( Y2, [ones(length(Y2),1), z_score1_diff_reg_2, w_score1_reg_2, abs(z_score1_diff_reg_2)]);
bz2 = breg(2);
bw2 = breg(3);
bzabs2 = breg(4);
b_int2= 0;

std_z2 = (int(end-1,2) - bz2)/1.96;
std_w2 = ( int(end,2) - bw2 )/1.96;
std_int2 = 0;
bz2_dummy=0;
std_z2_dummy=0;

[breg, int, ~,~,~] = regress( Y3, [ones(length(Y3),1), z_score1_diff_reg_3, w_score1_reg_3, abs(z_score1_diff_reg_3)]);
bz3 = breg(2);
bw3 = breg(3);
bzabs3 = breg(4);
b_int3= 0;

std_z3 = (int(end-1,2) - bz3)/1.96;
std_w3 = ( int(end,2) - bw3 )/1.96;
std_int3 = 0;
bz3_dummy=0;
std_z3_dummy=0;

[breg, int, ~,~,~] = regress( Y4, [ones(length(Y4),1), z_score1_diff_reg_4, w_score1_reg_4, abs(z_score1_diff_reg_4)]);
bz4 = breg(2);
bw4 = breg(3);
bzabs4 = breg(4);
b_int4= 0;

std_z4 = (int(end-1,2) - bz4)/1.96;
std_w4 = ( int(end,2) - bw4 )/1.96;
std_int4 = 0;
bz4_dummy=0;
std_z4_dummy=0;




[breg, int,~,~,~] = regress( Y1, [ones(length(Y1),1), z_score1_diff_reg_1, w_score1_reg_1, z_score1_diff_reg_1.*(z_score1_diff_reg_1<0)]);
bz = breg(2);
bw = breg(3);
bzabs = breg(4);
b_int= 0;

std_z = (int(end-1,2) - bz)/1.96;
std_w = ( int(end,2) - bw )/1.96;
std_int = 0;
bz_dummy=0;
std_z_dummy=0;


[breg, int, ~,~,~] = regress( Y2, [ones(length(Y2),1), z_score1_diff_reg_2, w_score1_reg_2, z_score1_diff_reg_2.*(z_score1_diff_reg_2<0)]);
bz2 = breg(2);
bw2 = breg(3);
bzabs2 = breg(4);
b_int2= 0;

std_z2 = (int(end-1,2) - bz2)/1.96;
std_w2 = ( int(end,2) - bw2 )/1.96;
std_int2 = 0;
bz2_dummy=0;
std_z2_dummy=0;

[breg, int, ~,~,~] = regress( Y3, [ones(length(Y3),1), z_score1_diff_reg_3, w_score1_reg_3, z_score1_diff_reg_3.*(z_score1_diff_reg_3<0)]);
bz3 = breg(2);
bw3 = breg(3);
bzabs3 = breg(4);
b_int3= 0;

std_z3 = (int(end-1,2) - bz3)/1.96;
std_w3 = ( int(end,2) - bw3 )/1.96;
std_int3 = 0;
bz3_dummy=0;
std_z3_dummy=0;

[breg, int, ~,~,~] = regress( Y4, [ones(length(Y4),1), z_score1_diff_reg_4, w_score1_reg_4, z_score1_diff_reg_4.*(z_score1_diff_reg_4<0)]);
bz4 = breg(2);
bw4 = breg(3);
bzabs4 = breg(4);
b_int4= 0;

std_z4 = (int(end-1,2) - bz4)/1.96;
std_w4 = ( int(end,2) - bw4 )/1.96;
std_int4 = 0;
bz4_dummy=0;
std_z4_dummy=0;


